#include <Engine/Globals.h>
#include <rewindow/logger/logger.h>
#include <Game/Scene/ControllableBox.h>
#include <Game/Scene/Loading.h>

using namespace JGL;

void CreateScenes() {
    auto ld = new LoadingScreen("LoadingScreen");
    Globals::SceneList.push_back(ld);

    auto cb = new ControllableBox("Scene0");
    Globals::SceneList.push_back(cb);
};

int main() {
    ReWindow::Logger::Error.EnableConsole(false);
    ReWindow::Logger::Warning.EnableConsole(false);
    ReWindow::Logger::Debug.EnableConsole(false);

    Globals::Window = new Engine::DemoGameWindow("Demo Game", 1024, 896);
    Globals::Window->SetRenderer(RenderingAPI::OPENGL);
    Globals::Window->Open();
    Globals::Window->InitGL();
    Globals::Window->SetResizable(false);
    Globals::Window->SetVsyncEnabled(false);

    CreateScenes();
    Globals::ChangeScene("LoadingScreen");

    while (Globals::Window->IsAlive())
        Globals::Window->ManagedRefresh();
}
