#include <Engine/Entity/Sprite.h>

Engine::Sprite::~Sprite() {
    delete texture;
    delete alpha_mask;
}

void Engine::Sprite::Render() {
    if (texture && !alpha_mask)
        J2D::DrawSprite(texture, position, face_angle, origin, scale, base_color);
    if (texture && alpha_mask)
        J2D::DrawSprite(texture, alpha_mask, position, face_angle, origin, scale, base_color);
}

AABB2D Engine::Sprite::GetBounds() {
    return { position, texture->GetDimensions() + position };
}

Texture* Engine::Sprite::GetTexture() {
    return texture;
}
