#include <Game/Scene/Loading.h>
#include <Engine/Globals.h>

void LoadingScreen::Init() {
    RedactedSoftware = new JGL::Texture("assets/sprites/Re3D.png");
}

void LoadingScreen::Update() {
        angle += (elapsed * 4) * Globals::DeltaTime();
    elapsed += Globals::DeltaTime();

    // Pretend we're actually loading something idk.
    if (elapsed >= 2.75)
        Globals::ChangeScene("Scene0");
}

void LoadingScreen::Render(RenderTarget* render_target) {
    auto text_length = JGL::Fonts::Jupiteroid.MeasureString("Loading ....", 24);
    std::string text = "Loading";
    int dots = static_cast<int>(floor(elapsed / 0.35)) % 4;
    for (int i = 0; i < dots; ++i)
        text += ".";

    J2D::Begin(render_target, true);
        J2D::DrawSprite(RedactedSoftware, {Globals::Window->GetSize().x - RedactedSoftware->GetDimensions().x, Globals::Window->GetSize().y - RedactedSoftware->GetDimensions().y}, angle, {0.5, 0.5});
        J2D::DrawString(Colors::Whites::Ivory, text, (Globals::Window->GetSize().x - text_length.x) - RedactedSoftware->GetDimensions().x , Globals::Window->GetSize().y - text_length.y * 1.125, 1, 24);
    J2D::End();
}


LoadingScreen::~LoadingScreen() {
    delete RedactedSoftware;
}


